SystemOrganization addCategory: #GridView!

RectangleMorph subclass: #GridCellMorph
	instanceVariableNames: 'clickAction row column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridView'!

!GridCellMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:16'!
column
	^ column! !

!GridCellMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:16'!
column: anObject
	column := anObject! !

!GridCellMorph methodsFor: 'event handling' stamp: 'NouryBouraqadi 9/28/2012 16:23'!
handlesMouseDown: evt
	^ clickAction notNil! !

!GridCellMorph methodsFor: 'event handling' stamp: 'NouryBouraqadi 9/28/2012 16:21'!
mouseDown: evt
	^self! !

!GridCellMorph methodsFor: 'event handling' stamp: 'NouryBouraqadi 9/28/2012 18:37'!
mouseUp: evt
	clickAction cull: self row cull: self column! !

!GridCellMorph methodsFor: 'event handling' stamp: 'NouryBouraqadi 9/28/2012 16:22'!
onClickDo: aBlock
	clickAction := aBlock ! !

!GridCellMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:16'!
row
	^ row! !

!GridCellMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:16'!
row: anObject
	row := anObject! !

Morph subclass: #GridMorph
	instanceVariableNames: 'cells cellExtent rowCount columnCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridView'!

!GridMorph class methodsFor: 'instance creation' stamp: 'NouryBouraqadi 9/28/2012 09:08'!
rowCount: numberOfCellsHorizontally columnCount: numberOfCellsVertically 
	^self new
		rowCount: numberOfCellsHorizontally columnCount: numberOfCellsVertically;
		yourself! !

!GridMorph class methodsFor: 'instance creation' stamp: 'NouryBouraqadi 9/28/2012 08:50'!
width: width height: height 
	^self new
		width: width height: height;
		yourself! !

!GridMorph methodsFor: 'colors' stamp: 'NouryBouraqadi 10/3/2012 11:41'!
borderColor: aColor at: row at: column
	(self cellAt: row at: column) borderColor: aColor.
	^self borderColorAt: row at: column! !

!GridMorph methodsFor: 'colors' stamp: 'NouryBouraqadi 9/28/2012 15:47'!
borderColorAt: row at: column 
	^(self cellAt: row at: column) borderColor! !

!GridMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 15:40'!
cellAt: row at: column 
	^self cells at: row at: column! !

!GridMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 09:14'!
cellClass
	^GridCellMorph! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:44'!
cellExtent
	^ cellExtent! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:54'!
cellExtent: aPoint
	cellExtent := aPoint.
	self updateGeometry ! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:47'!
cellHeight
	^self cellExtent y! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:47'!
cellHeight: newHeight
	self cellExtent: self cellWidth @ newHeight! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:47'!
cellWidth
	^self cellExtent x! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 09:47'!
cellWidth: newWidth
	self cellExtent: newWidth @ self cellWidth ! !

!GridMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 08:55'!
cells
	^cells! !

!GridMorph methodsFor: 'colors' stamp: 'NouryBouraqadi 10/3/2012 11:37'!
color: aColor at: row at: column
	(self cellAt: row at: column) color: aColor.
	^self colorAt: row at: column! !

!GridMorph methodsFor: 'colors' stamp: 'NouryBouraqadi 9/28/2012 15:40'!
colorAt: row at: column 
	^(self cellAt: row at: column) color! !

!GridMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:19'!
columnCount
	^columnCount! !

!GridMorph methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/28/2012 09:37'!
defaultCellHeight
	^10! !

!GridMorph methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/28/2012 09:37'!
defaultCellWidth
	^10! !

!GridMorph methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/28/2012 18:21'!
initialize
	super initialize.
	self cellExtent: self defaultCellWidth@self defaultCellHeight! !

!GridMorph methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 9/28/2012 18:18'!
newCellAt: row at: column
	^self cellClass new
		row: row;
		column: column;
		yourself! !

!GridMorph methodsFor: 'event handling' stamp: 'NouryBouraqadi 9/28/2012 16:24'!
onClickDo: aBlock
	self cells do: [:aCell| aCell onClickDo: aBlock]! !

!GridMorph methodsFor: 'accessing' stamp: 'NouryBouraqadi 9/28/2012 18:19'!
rowCount
	^rowCount! !

!GridMorph methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/3/2012 12:05'!
rowCount: numberOfCellsHorizontally columnCount: numberOfCellsVertically 
	rowCount := numberOfCellsHorizontally.
	columnCount := numberOfCellsVertically.
	cells := (Matrix 
					rows: numberOfCellsHorizontally 
					columns: numberOfCellsVertically 
					tabulate: [:row :column| 
						self newCellAt: row at: column]).
	self addAllMorphs: cells.
	self updateGeometry.
	^cells rowCount  @ cells columnCount ! !

!GridMorph methodsFor: 'geometry' stamp: 'NouryBouraqadi 9/28/2012 18:22'!
updateGeometry
	self cells ifNil: [^self].
	self extent: self cellExtent * (self rowCount@self columnCount).
	cells do: [:aCell|
		|x y|
		x := self cellWidth * (aCell row -1).
		y := self cellHeight * (aCell column - 1).
		aCell position: (x@y) + self position.
		aCell extent: self cellExtent 
	]! !

TestCase subclass: #GridMorphTest
	instanceVariableNames: 'grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GridView'!

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 10:29'!
assertCellsAreAllInsideGrid
	| gridCorner |
	self assert: (grid cells allSatisfy: [:cell| grid position <= cell position]).
	gridCorner := grid position + grid extent.
	self assert: (grid cells allSatisfy: [:cell|  (cell position + cell extent) <= gridCorner])
	! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:06'!
setUp
	super setUp.
	grid := GridMorph rowCount: 3 columnCount: 4! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:23'!
testCellPositions
	| cellSideLength expectedX expectedY |
	cellSideLength := grid cellWidth.
	grid cells do: [:aCell|
		expectedX := cellSideLength * (aCell row - 1).
		expectedY := cellSideLength * (aCell column - 1).
		self assert: aCell position = (expectedX@expectedY) 
	]! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 10:30'!
testCellsAreAllInitiallyInsideGrid
	self assertCellsAreAllInsideGrid ! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:23'!
testCellsAreSubmorphsOfGrid
	self assert: (grid submorphs includesAllOf: grid cells)! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 08:55'!
testCellsCount
	self assert: grid cells size = 12! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:31'!
testCellsDefaultHeight
	self assert: (grid cells allSatisfy: [:cell| cell height = grid cellHeight]).
! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:31'!
testCellsDefaultWidth
	self assert: (grid cells allSatisfy: [:cell| cell width = grid cellWidth]).
! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:35'!
testCellsHeightChange
	| originalWidth |
	originalWidth := grid cellWidth.
	grid cellHeight: 2 * grid cellHeight.
	self assert: (grid cells allSatisfy: [:cell| cell height = grid cellHeight]).
	self assert: (grid cells allSatisfy: [:cell| cell width = originalWidth]).
! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 10:30'!
testCellsRemainInsideGridAfterMove
	| gridCorner |
	grid position: 100@200.
 	self assertCellsAreAllInsideGrid ! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:34'!
testCellsWidthChange
	| originalHeight |
	originalHeight := grid cellHeight.
	grid cellWidth: 2 * grid cellWidth.
	self assert: (grid cells allSatisfy: [:cell| cell height = originalHeight]).
	self assert: (grid cells allSatisfy: [:cell| cell width = grid cellWidth]).
! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 16:25'!
testClickAction
	| clickCount |
	clickCount := 0.
	grid onClickDo: [:evt| clickCount := clickCount + 1].
	grid cells do: [:aCell| aCell click].
	self assert: clickCount = grid cells size! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:30'!
testGridHeight
	self assert: grid height = (grid columnCount * grid cellHeight)! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 09:30'!
testGridWidth
	self assert: grid width = (grid rowCount * grid cellWidth)! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:16'!
testSetCellBorderColor
	| colors |
	colors := {Color red. Color blue. Color yellow. Color green. Color tan. Color cyan. Color magenta}.
	grid cells do: [:cell|
		colors do: [:aColor|
			grid borderColor: aColor at: cell row at: cell column.
			self assert: cell borderColor = aColor
			]
	]! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 10/3/2012 11:52'!
testSetCellBorderColorAnswersTheProvidedColor
	| colors |
	colors := {Color red. Color blue. Color yellow. Color green. Color tan. Color cyan. Color magenta}.
	grid cells do: [:cell|
		colors do: [:aColor|
			|result|
			result := grid borderColor: aColor at: cell row at: cell column.
			self assert: result = aColor
			]
	]! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 9/28/2012 18:17'!
testSetCellColor
	| colors |
	colors := {Color red. Color blue. Color yellow. Color green. Color tan. Color cyan. Color magenta}.
	grid cells do: [:cell |
		colors do: [:aColor|
			grid color: aColor at: cell row at: cell column.
			self assert: cell color = aColor
			]
	]! !

!GridMorphTest methodsFor: 'testing' stamp: 'NouryBouraqadi 10/3/2012 11:51'!
testSetCellColorAnswersTheProvidedColor
	| colors |
	colors := {Color red. Color blue. Color yellow. Color green. Color tan. Color cyan. Color magenta}.
	grid cells do: [:cell |
		colors do: [:aColor|
			|result|
			result := grid color: aColor at: cell row at: cell column.
			self assert: result = aColor
			]
	]! !
